(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
  typeof define === 'function' && define.amd ? define(['exports'], factory) :
  (global = global || self, factory(global.chartix = {}));
}(this, (function (exports) { 'use strict';

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
      keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};

      if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }

    return target;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  function _construct(Parent, args, Class) {
    if (isNativeReflectConstruct()) {
      _construct = Reflect.construct;
    } else {
      _construct = function _construct(Parent, args, Class) {
        var a = [null];
        a.push.apply(a, args);
        var Constructor = Function.bind.apply(Parent, a);
        var instance = new Constructor();
        if (Class) _setPrototypeOf(instance, Class.prototype);
        return instance;
      };
    }

    return _construct.apply(null, arguments);
  }

  function _isNativeFunction(fn) {
    return Function.toString.call(fn).indexOf("[native code]") !== -1;
  }

  function _wrapNativeSuper(Class) {
    var _cache = typeof Map === "function" ? new Map() : undefined;

    _wrapNativeSuper = function _wrapNativeSuper(Class) {
      if (Class === null || !_isNativeFunction(Class)) return Class;

      if (typeof Class !== "function") {
        throw new TypeError("Super expression must either be null or a function");
      }

      if (typeof _cache !== "undefined") {
        if (_cache.has(Class)) return _cache.get(Class);

        _cache.set(Class, Wrapper);
      }

      function Wrapper() {
        return _construct(Class, arguments, _getPrototypeOf(this).constructor);
      }

      Wrapper.prototype = Object.create(Class.prototype, {
        constructor: {
          value: Wrapper,
          enumerable: false,
          writable: true,
          configurable: true
        }
      });
      return _setPrototypeOf(Wrapper, Class);
    };

    return _wrapNativeSuper(Class);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    }

    return _assertThisInitialized(self);
  }

  function _superPropBase(object, property) {
    while (!Object.prototype.hasOwnProperty.call(object, property)) {
      object = _getPrototypeOf(object);
      if (object === null) break;
    }

    return object;
  }

  function _get(target, property, receiver) {
    if (typeof Reflect !== "undefined" && Reflect.get) {
      _get = Reflect.get;
    } else {
      _get = function _get(target, property, receiver) {
        var base = _superPropBase(target, property);

        if (!base) return;
        var desc = Object.getOwnPropertyDescriptor(base, property);

        if (desc.get) {
          return desc.get.call(receiver);
        }

        return desc.value;
      };
    }

    return _get(target, property, receiver || target);
  }

  var Component =
  /*#__PURE__*/
  function () {
    function Component() {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      _classCallCheck(this, Component);

      _defineProperty(this, "started", false);

      _defineProperty(this, "chart", null);

      this.props = props;
      this.itemsKey = this.constructor.itemsKey || 'items';
      this[this.itemsKey] = props[this.itemsKey] || [];
    }

    _createClass(Component, [{
      key: "add",
      value: function add(item) {
        this[this.itemsKey].push(item);
        if (this.started) item.start && item.start(this.chart);
      }
    }, {
      key: "remove",
      value: function remove(item) {
        var index = this[this.itemsKey].indexOf(item);
        if (index === -1) return false;
        this[this.itemsKey].splice(index, 1);
        item.stop && item.stop();
        return true;
      }
    }, {
      key: "start",
      value: function start(chart) {
        if (this.started) return;
        this.started = true;
        this.chart = chart;
        this[this.itemsKey].forEach(function (item) {
          return item.start && item.start(chart);
        });
      }
    }, {
      key: "stop",
      value: function stop() {
        if (this.started) {
          this.started = false;
          this[this.itemsKey].forEach(function (item) {
            return item.stop && item.stop();
          });
        }
      }
    }, {
      key: "draw",
      value: function draw() {
        if (!this.started) return;
        this[this.itemsKey].forEach(function (item) {
          return item.draw && item.draw();
        });
      }
    }]);

    return Component;
  }();

  var spliceFromBoundStore = function spliceFromBoundStore(store, i) {
    store.names.splice(i, 1);
    store.listeners.splice(i, 1);
    store.zIndexes.splice(i, 1);
  };

  var Events =
  /*#__PURE__*/
  function () {
    function Events(element) {
      var _this = this;

      _classCallCheck(this, Events);

      _defineProperty(this, "boundListenersObjects", []);

      _defineProperty(this, "boundListeners", []);

      _defineProperty(this, "listeners", {});

      _defineProperty(this, "sortedKeys", {});

      _defineProperty(this, "handleBrowserEvent", function (e) {
        _this.emitEvent(e.type, e);
      });

      this.element = element;
    }

    _createClass(Events, [{
      key: "bindListener",
      value: function bindListener(object, name, listener, zIndex) {
        var _this2 = this;

        var index = this.boundListenersObjects.indexOf(object);

        if (index === -1) {
          index = this.boundListenersObjects.length;
          this.boundListenersObjects[index] = object;
          var stop = object.stop;
          var _store = {
            names: [],
            listeners: [],
            zIndexes: [],
            stop: stop
          };
          this.boundListeners[index] = _store;
          if (stop) object.stop = function () {
            stop.call(object);

            _this2.unbindListeners(_store);
          };else object.stop = function () {
            return _this2.unbindListeners(_store);
          };
        }

        var store = this.boundListeners[index];

        if (store.listeners.indexOf(listener) === -1) {
          store.names.push(name);
          store.listeners.push(listener);
          store.zIndexes.push(zIndex);
        }

        this.addListener(name, listener, zIndex);
      }
    }, {
      key: "unbindListeners",
      value: function unbindListeners(store) {
        var _this3 = this;

        store.names.forEach(function (name, i) {
          _this3.removeListener(name, store.listeners[i], store.zIndexes[i]);
        });
      }
    }, {
      key: "removeBoundListener",
      value: function removeBoundListener(object) {
        var name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
        var listener = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
        var index = this.boundListenersObjects.indexOf(object);
        if (index === -1) return;
        var store = this.boundListeners[index];

        if (listener) {
          var storeIndex = store.listeners.indexOf(listener);
          if (storeIndex !== -1) spliceFromBoundStore(store, storeIndex);
        } else if (name) {
          var _storeIndex;

          while ((_storeIndex = store.names.indexOf(name)) !== -1) {
            spliceFromBoundStore(store, _storeIndex);
          }
        }

        if (!name || store.names.length === 0) {
          this.boundListenersObjects.splice(index, 1);
          this.boundListeners.splice(index, 1);
          object.stop = store.stop;
        }
      }
    }, {
      key: "addListener",
      value: function addListener(name, listener) {
        var zIndex = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
        var listeners = this.listeners[name];

        if (!listeners) {
          this.listeners[name] = listeners = {};
          this.sortedKeys[name] = [];
          if (this.element && this.element['on' + name] !== undefined) this.element.addEventListener(name, this.handleBrowserEvent);
        }

        if (!listeners[zIndex]) {
          listeners[zIndex] = [];
          this.sortedKeys[name].push(zIndex);
          this.sortedKeys[name].sort(function (a, b) {
            return a < b ? 1 : -1;
          });
        }

        if (listeners[zIndex].indexOf(listener) === -1) listeners[zIndex].push(listener);
      }
    }, {
      key: "removeListener",
      value: function removeListener(name, listener) {
        var zIndex = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
        var listeners = this.listeners[name];
        if (!listeners || !listeners[zIndex]) return;
        var index = listeners[zIndex].indexOf(listener);
        if (index === -1) return;
        listeners[zIndex].splice(index, 1);

        if (listeners[zIndex].length === 0) {
          delete listeners[zIndex];
          this.sortedKeys[name].splice(this.sortedKeys[name].indexOf(zIndex), 1);

          if (Object.keys(listeners).length === 0) {
            delete this.listeners[name];
            delete this.sortedKeys[name];
            if (this.element && this.element['on' + name] !== undefined) this.element.removeEventListener(name, this.handleBrowserEvent);
          }
        }
      }
    }, {
      key: "emit",
      value: function emit(name, target) {
        var data = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
        data.target = target;
        data.type = name;
        this.emitEvent(name, data);
      }
    }, {
      key: "emitEvent",
      value: function emitEvent(name, event) {
        var typeListeners = this.listeners[name];
        if (!typeListeners) return;
        var propagationStopped = false;

        var stopPropagation = function stopPropagation() {
          return propagationStopped = true;
        };

        var keys = this.sortedKeys[name];

        for (var i = 0; i < keys.length; i++) {
          typeListeners[keys[i]].forEach(function (listener) {
            return listener.call(null, event, stopPropagation);
          });
          if (propagationStopped) return;
        }
      }
    }]);

    return Events;
  }();

  var scaleX = function scaleX(_ref, x) {
    var scaleX = _ref.scaleX,
        offsetX = _ref.offsetX;
    return x * scaleX - offsetX;
  };
  var unscaleX = function unscaleX(_ref2, x) {
    var scaleX = _ref2.scaleX,
        offsetX = _ref2.offsetX;
    return (x + offsetX) / scaleX;
  };
  var contain = function contain(obj, x, y) {
    return x >= obj.x && x <= obj.x + obj.width && y >= obj.y && y <= obj.y + obj.height;
  };
  var drawRect = function drawRect(obj) {
    var context = obj.chart.context;
    var _obj$props = obj.props,
        draw = _obj$props.draw,
        style = _obj$props.context;

    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    if (draw) return draw.apply(void 0, [context, obj].concat(args));
    Object.assign(context, style);
    context.beginPath();
    context.rect(obj.x, obj.y, obj.width, obj.height);
    context.stroke();
    context.fill();
  };
  var shallowEqual = function shallowEqual(a, b) {
    if (a === b) return true;
    if (!a || !b || Object.keys(a).length !== Object.keys(b).length) return false;

    for (var key in a) {
      if (a[key] !== b[key]) return false;
    }

    return true;
  };

  var Utils = /*#__PURE__*/Object.freeze({
    __proto__: null,
    scaleX: scaleX,
    unscaleX: unscaleX,
    contain: contain,
    drawRect: drawRect,
    shallowEqual: shallowEqual
  });

  var Scroll =
  /*#__PURE__*/
  function () {
    function Scroll() {
      var _this = this;

      _classCallCheck(this, Scroll);

      _defineProperty(this, "mouseX", null);

      _defineProperty(this, "handleScaleChange", function (_ref) {
        var was = _ref.was;
        var target = _this.mouseX === null ? _this.chart.width / 2 : _this.mouseX;
        _this.chart.offsetX = (_this.chart.offsetX + target) / was * _this.chart.scaleX - target;
      });

      _defineProperty(this, "handleWheel", function (e) {
        if (e.deltaX === 0) return;
        e.preventDefault();
        var was = _this.chart.offsetX;
        var offsetX = was + e.deltaX;

        if (_this.chart.offsetX !== offsetX) {
          _this.chart.offsetX = offsetX;

          _this.chart.events.emit('offsetXChange', _this, {
            was: was
          });

          _this.chart.draw();
        }
      });

      _defineProperty(this, "handleMousemove", function (e) {
        return _this.mouseX = e.layerX;
      });

      _defineProperty(this, "handleMouseout", function () {
        return _this.mouseX = null;
      });
    }

    _createClass(Scroll, [{
      key: "start",
      value: function start(chart) {
        this.chart = chart;
        this.canvas = chart.canvas;
        chart.events.bindListener(this, 'scaleXChange', this.handleScaleChange);
        chart.events.bindListener(this, 'wheel', this.handleWheel);
        chart.events.bindListener(this, 'mousemove', this.handleMousemove);
        chart.events.bindListener(this, 'mouseout', this.handleMouseout);
      }
    }]);

    return Scroll;
  }();

  var Zoom =
  /*#__PURE__*/
  function () {
    function Zoom() {
      var _this = this;

      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      _classCallCheck(this, Zoom);

      _defineProperty(this, "handleWheel", function (e) {
        if (!e.ctrlKey) return;
        e.preventDefault();
        var scaleX = _this.chart.scaleX;
        _this.chart.scaleX -= e.deltaY * _this.scaleFactor * _this.chart.scaleX;

        _this.chart.events.emit('scaleXChange', _this, {
          was: scaleX
        });

        _this.chart.draw();
      });

      this.scaleFactor = 0.01;
      Object.assign(this, options);
    }

    _createClass(Zoom, [{
      key: "start",
      value: function start(chart) {
        this.chart = chart;
        this.canvas = chart.canvas;
        chart.events.bindListener(this, 'wheel', this.handleWheel);
      }
    }]);

    return Zoom;
  }();

  var Path =
  /*#__PURE__*/
  function (_Path2D) {
    _inherits(Path, _Path2D);

    function Path(_ref) {
      var _this;

      var values = _ref.values,
          _ref$minValue = _ref.minValue,
          minValue = _ref$minValue === void 0 ? -1 : _ref$minValue,
          _ref$maxValue = _ref.maxValue,
          maxValue = _ref$maxValue === void 0 ? 1 : _ref$maxValue,
          scaleX = _ref.scaleX,
          offsetX = _ref.offsetX,
          width = _ref.width,
          height = _ref.height,
          stretch = _ref.stretch,
          _ref$top = _ref.top,
          top = _ref$top === void 0 ? 0 : _ref$top,
          xValues = _ref.xValues,
          lowValues = _ref.lowValues,
          highValues = _ref.highValues,
          fill = _ref.fill;

      _classCallCheck(this, Path);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(Path).call(this));
      _this.values = values;
      _this.minValue = minValue;
      _this.maxValue = maxValue;
      _this.scaleX = scaleX;
      _this.offsetX = offsetX;
      _this.width = width;
      _this.height = height;
      _this.stretch = stretch;
      _this.xValues = xValues;
      _this.lowValues = lowValues;
      _this.highValues = highValues;
      _this.fill = fill;
      _this.halfHeight = height / 2;
      _this.top = top;

      _this.draw();

      return _this;
    }

    _createClass(Path, [{
      key: "draw",
      value: function draw() {
        var values = this.values,
            minValue = this.minValue,
            maxValue = this.maxValue,
            scaleX = this.scaleX,
            offsetX = this.offsetX,
            width = this.width,
            stretch = this.stretch,
            xValues = this.xValues,
            lowValues = this.lowValues,
            highValues = this.highValues;
        var valueI = 0;
        var last = values.length - 1;
        var showingCount = values.length / scaleX;
        var dense = showingCount > width;
        var min, max, minI, maxI;
        var toI = Math.floor(offsetX * showingCount / width) - 1;
        var x = 0;

        for (; x < width; x++) {
          var fromI = toI;
          if (fromI > last) break;
          toI = Math.floor((offsetX + x + 1) * showingCount / width);

          if (fromI >= 0) {
            xValues[valueI] = x;

            if (dense) {
              max = minValue;
              min = maxValue;

              for (var i = fromI; i < toI; i++) {
                if (dense && min > values[i]) {
                  min = values[i];
                  minI = i;
                }

                if (max < values[i]) {
                  max = values[i];
                  maxI = i;
                }
              }

              lowValues[valueI] = values[minI];
              highValues[valueI++] = values[maxI];
            } else {
              highValues[valueI++] = values[fromI];
            }
          }
        }

        if (valueI === 0) return;
        var highFactor = 1;
        var lowFactor = 1;

        if (stretch) {
          max = minValue;
          highValues.forEach(function (value) {
            if (max < value) max = value;
          });
          highFactor = maxValue / max;
          this.highFactor = highFactor;
          min = maxValue;
          (dense ? lowValues : highValues).forEach(function (value) {
            if (min > value) min = value;
          });
          lowFactor = minValue / min;
          this.lowFactor = lowFactor;
        }

        if (this.fill) this.lineTo(xValues[0] - 1, this.halfHeight);

        if (dense) {
          var count = 0;

          for (var _i = 0; _i < valueI; _i++) {
            if (highValues[_i] < 0) count++;
          }

          if (count / valueI < 0.3) {
            for (var _i2 = 0; _i2 < valueI; _i2++) {
              this.drawPoint(_i2, highValues, highFactor, lowFactor);
            }

            for (var _i3 = valueI - 1; _i3 >= 0; _i3--) {
              this.drawPoint(_i3, lowValues, highFactor, lowFactor);
            }
          } else {
            for (var _i4 = 0; _i4 < valueI; _i4++) {
              if (highValues[_i4] > 0) this.drawPoint(_i4, highValues, highFactor, lowFactor);
              if (lowValues[_i4] < 0) this.drawPoint(_i4, lowValues, highFactor, lowFactor);
            }

            this.lineTo(x, this.halfHeight);
          }
        } else {
          for (var _i5 = 0; _i5 < valueI; _i5++) {
            this.drawPoint(_i5, highValues, highFactor, lowFactor);
          }

          if (this.fill) this.lineTo(x, this.halfHeight);
        }
      }
    }, {
      key: "drawPoint",
      value: function drawPoint(i, array, highFactor, lowFactor) {
        var value = array[i];
        value *= (value > 0 ? highFactor : lowFactor) || 1;
        this.lineTo(this.xValues[i], this.valueToY(value));
      }
    }, {
      key: "valueToY",
      value: function valueToY(value) {
        return this.halfHeight - this.halfHeight * value + this.top;
      }
    }]);

    return Path;
  }(_wrapNativeSuper(Path2D));

  var Wave =
  /*#__PURE__*/
  function (_Component) {
    _inherits(Wave, _Component);

    function Wave() {
      var _getPrototypeOf2;

      var _this;

      _classCallCheck(this, Wave);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Wave)).call.apply(_getPrototypeOf2, [this].concat(args)));

      _defineProperty(_assertThisInitialized(_this), "path", null);

      _defineProperty(_assertThisInitialized(_this), "pathArguments", null);

      return _this;
    }

    _createClass(Wave, [{
      key: "draw",
      value: function draw() {
        if (this.props.values.length === 0) return;
        this.setupValuesArrays();
        var _this$chart = this.chart,
            width = _this$chart.width,
            height = _this$chart.height,
            offsetX = _this$chart.offsetX,
            scaleX = _this$chart.scaleX;

        var pathArguments = _objectSpread2({
          width: width,
          height: height,
          offsetX: offsetX,
          scaleX: scaleX
        }, this.props);

        if (!this.path || !shallowEqual(this.pathArguments, pathArguments)) {
          this.path = new Path(pathArguments);
          this.pathArguments = pathArguments;
        }

        this.drawer();
      }
    }, {
      key: "drawer",
      value: function drawer() {
        if (this.props.draw) return this.props.draw(this.chart, this.path, this.props);
        this.chart.context.stroke(this.path);
        this.chart.context.fill(this.path);
      }
    }, {
      key: "setupValuesArrays",
      value: function setupValuesArrays() {
        var values = this.props.values;
        var width = this.chart.width;
        if (this.props.xValues) if (this.props.xValues.length === width) {
          if (this.props.lowValues.constructor === values.constructor) return;
        } else if (Array.isArray(this.props.lowValues) && Array.isArray(values)) {
          this.props.xValues = new Uint16Array(width);
          this.props.lowValues.length = width;
          this.props.highValues.length = width;
          return;
        }
        this.props.xValues = new Uint16Array(width);
        this.props.lowValues = new values.constructor(width);
        this.props.highValues = new values.constructor(width);
      }
    }, {
      key: "highFactor",
      get: function get() {
        return this.path.highFactor;
      }
    }, {
      key: "lowFactor",
      get: function get() {
        return this.path.lowFactor;
      }
    }]);

    return Wave;
  }(Component);

  var defaults = {
    nearPixels: 3,
    removable: false,
    resizable: false,
    context: {
      strokeStyle: 'rgba(0, 188, 212, 0.3)',
      fillStyle: 'rgba(0, 188, 212, 0.1)'
    }
  };

  var Selection =
  /*#__PURE__*/
  function (_Component) {
    _inherits(Selection, _Component);

    _createClass(Selection, [{
      key: "from",
      get: function get() {
        return this.x;
      },
      set: function set(value) {
        this.width = this.width + this.x - value;
        this.x = value;
      }
    }, {
      key: "to",
      get: function get() {
        return this.x + this.width;
      },
      set: function set(value) {
        this.width = value - this.x;
      }
    }]);

    function Selection(props) {
      var _this;

      _classCallCheck(this, Selection);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(Selection).call(this, Object.assign({}, defaults, props)));

      _defineProperty(_assertThisInitialized(_this), "removeReady", false);

      _defineProperty(_assertThisInitialized(_this), "resizeReady", false);

      _defineProperty(_assertThisInitialized(_this), "resizing", false);

      _defineProperty(_assertThisInitialized(_this), "cursorWas", '');

      _defineProperty(_assertThisInitialized(_this), "nearPixels", 3);

      _defineProperty(_assertThisInitialized(_this), "x", null);

      _defineProperty(_assertThisInitialized(_this), "y", null);

      _defineProperty(_assertThisInitialized(_this), "width", null);

      _defineProperty(_assertThisInitialized(_this), "height", null);

      _defineProperty(_assertThisInitialized(_this), "events", new Events());

      _defineProperty(_assertThisInitialized(_this), "drawIcon", function (context, icon, selection) {
        var iconSign = "\u02DF";
        icon.x = scaleX(selection.chart, selection.props.to) - 20;
        context.textBaseline = 'top';
        context.font = '30px Arial';

        if (!icon.y) {
          icon.y = 10;
          var measurement = context.measureText(iconSign);
          icon.width = measurement.width;
          icon.height = measurement.actualBoundingBoxDescent / 2;
        }

        context.fillStyle = 'rgba(244, 67, 54, 0.6)';
        context.fillText(iconSign, icon.x, icon.y);
      });

      _defineProperty(_assertThisInitialized(_this), "handleMousedown", function (e, stopPropagation) {
        var resizeReady = _this.props.resizable && _this.resizeReady;
        var removeReady = _this.props.removable && _this.removeReady;
        if (!resizeReady && !removeReady) return;
        stopPropagation();
        if (resizeReady) _this.resizing = true;else if (removeReady) {
          _this.remove();

          _this.chart.canvas.style.cursor = _this.cursorWas;
        }
      });

      _defineProperty(_assertThisInitialized(_this), "handleMouseup", function () {
        if (_this.resizing) {
          _this.resizing = false;

          _this.events.emit('resizeStop', _assertThisInitialized(_this));
        }
      });

      _defineProperty(_assertThisInitialized(_this), "handleMousemove", function (e) {
        var nearPixels = _this.props.nearPixels;

        var _assertThisInitialize = _assertThisInitialized(_this),
            chart = _assertThisInitialize.chart,
            from = _assertThisInitialize.from,
            to = _assertThisInitialize.to,
            icon = _assertThisInitialize.icon;

        var x = e.layerX,
            y = e.layerY;

        if (_this.props.resizable && _this.resizing) {
          var name;

          if (Math.abs(x - from) < Math.abs(x - to)) {
            _this.props.from = unscaleX(chart, x);
            name = 'from';
          } else {
            _this.props.to = unscaleX(chart, x);
            name = 'to';
          }

          if (_this.props.from > _this.props.to) {
            var fromWas = _this.props.from;
            _this.props.from = _this.props.to;
            _this.props.to = fromWas;
            name = 'both';
          }

          _this.events.emit('resize', _assertThisInitialized(_this), {
            name: name
          });

          return chart.draw();
        }

        if (_this.props.removable && contain(icon, x, y)) {
          if (!_this.removeReady) {
            _this.removeReady = true;
            _this.cursorWas = _this.chart.canvas.style.cursor;
            chart.canvas.style.cursor = 'pointer';
          }
        } else if (_this.props.resizable && (x > from - nearPixels && x < from + nearPixels || x > to - nearPixels && x < to + nearPixels)) {
          if (!_this.resizeReady) {
            _this.resizeReady = true;
            _this.cursorWas = _this.chart.canvas.style.cursor;
            chart.canvas.style.cursor = 'ew-resize';
          }
        } else if (_this.props.resizable && _this.resizeReady || _this.props.removable && _this.removeReady) {
          _this.resizeReady = _this.removeReady = false;
          chart.canvas.style.cursor = _this.cursorWas;
        }
      });

      _this.icon = new Component({
        draw: props.drawIcon || _this.drawIcon
      });
      return _this;
    }

    _createClass(Selection, [{
      key: "start",
      value: function start(chart) {
        _get(_getPrototypeOf(Selection.prototype), "start", this).call(this, chart);

        this.icon.start(chart);
        chart.events.bindListener(this, 'mousedown', this.handleMousedown, this.props.zIndex);
        chart.events.bindListener(this, 'mouseup', this.handleMouseup);
        chart.events.bindListener(this, 'mousemove', this.handleMousemove);
      }
    }, {
      key: "draw",
      value: function draw() {
        var chart = this.chart;
        this.from = scaleX(chart, this.props.from);
        this.to = scaleX(chart, this.props.to);
        this.y = -1;
        this.height = chart.height + 2;
        drawRect(this);
        if (this.props.removable) drawRect(this.icon, this);
      }
    }, {
      key: "remove",
      value: function remove() {
        this.events.emit('remove', this);
        this.stop();
      }
    }, {
      key: "interactive",
      get: function get() {
        return this.props.resizable || this.props.removable;
      },
      set: function set(value) {
        this.props.resizable = this.props.removable = value;
      }
    }]);

    return Selection;
  }(Component);

  var defaults$1 = {
    addable: false,
    resizable: false,
    removable: false,
    zIndex: 0,
    multiple: true
  };

  var RangeSelector =
  /*#__PURE__*/
  function (_Component) {
    _inherits(RangeSelector, _Component);

    function RangeSelector(props) {
      var _this;

      _classCallCheck(this, RangeSelector);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(RangeSelector).call(this, Object.assign({}, defaults$1, props)));

      _defineProperty(_assertThisInitialized(_this), "events", new Events());

      _defineProperty(_assertThisInitialized(_this), "handleMousedown", function (e, stopPropagation) {
        if (!_this.addable) return;
        if (_this.props.multiple === false && _this.selections.length) _this.remove(_this.selections[0], true);
        var unscaledX = unscaleX(_this.chart, e.layerX);

        var selection = _this.addSelection({
          from: unscaledX,
          to: unscaledX
        });

        selection.draw();
        selection.handleMousemove(e, stopPropagation);
        selection.handleMousedown(e, stopPropagation);
      });

      _defineProperty(_assertThisInitialized(_this), "handleSelection", function (e) {
        _this.events.emit(e.type + 'Selection', _assertThisInitialized(_this), _objectSpread2({
          selection: e.target
        }, e));
      });

      _defineProperty(_assertThisInitialized(_this), "handleRemoveSelection", function (_ref) {
        var target = _ref.target;

        _this.remove(target);
      });

      if (props.interactive !== null) _this.interactive = props.interactive;
      return _this;
    }

    _createClass(RangeSelector, [{
      key: "addSelection",
      value: function addSelection(props) {
        return this.add(new Selection(props));
      }
    }, {
      key: "add",
      value: function add(selection) {
        selection.props.zIndex = this.props.zIndex + 1;
        selection.props.resizable = this.props.resizable;
        selection.props.removable = this.props.removable;
        this.events.emit('addSelection', this, {
          selection: selection
        });
        this.bindSelectionListeners(selection);

        _get(_getPrototypeOf(RangeSelector.prototype), "add", this).call(this, selection);

        return selection;
      }
    }, {
      key: "start",
      value: function start(chart) {
        _get(_getPrototypeOf(RangeSelector.prototype), "start", this).call(this, chart);

        this.bindListeners();
      }
    }, {
      key: "remove",
      value: function remove(selection) {
        var move = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
        if (!_get(_getPrototypeOf(RangeSelector.prototype), "remove", this).call(this, selection)) return;
        selection.stop();
        this.events.emit('removeSelection', this, {
          selection: selection,
          move: move
        });
        this.chart.draw();
      }
    }, {
      key: "bindListeners",
      value: function bindListeners() {
        this.chart.events.bindListener(this, 'mousedown', this.handleMousedown, this.zIndex);
        this.selections.forEach(this.bindSelectionListeners, this);
      }
    }, {
      key: "bindSelectionListeners",
      value: function bindSelectionListeners(selection) {
        selection.events.bindListener(selection, 'resize', this.handleSelection);
        selection.events.bindListener(selection, 'resizeStop', this.handleSelection);
        selection.events.bindListener(selection, 'remove', this.handleRemoveSelection);
      }
    }, {
      key: "addable",
      get: function get() {
        return this.props.addable;
      },
      set: function set(value) {
        this.props.addable = value;
      }
    }, {
      key: "resizable",
      get: function get() {
        return this.props.resizable;
      },
      set: function set(value) {
        this.props.resizable = value;
        this.selections.forEach(function (selection) {
          return selection.props.resizable = value;
        });
      }
    }, {
      key: "removable",
      get: function get() {
        return this.props.removable;
      },
      set: function set(value) {
        this.props.removable = value;
        this.selections.forEach(function (selection) {
          return selection.props.removable = value;
        });
      }
    }, {
      key: "interactive",
      get: function get() {
        return this.addable && this.resizable && this.removable;
      },
      set: function set(value) {
        this.addable = this.resizable = this.removable = value;
      }
    }]);

    return RangeSelector;
  }(Component);

  _defineProperty(RangeSelector, "itemsKey", 'selections');

  var Axis =
  /*#__PURE__*/
  function (_Component) {
    _inherits(Axis, _Component);

    function Axis(_ref) {
      var _this;

      var from = _ref.from,
          to = _ref.to,
          _ref$side = _ref.side,
          side = _ref$side === void 0 ? 'bottom' : _ref$side,
          _ref$textSize = _ref.textSize,
          textSize = _ref$textSize === void 0 ? 14 : _ref$textSize,
          _ref$font = _ref.font,
          font = _ref$font === void 0 ? "".concat(textSize, "px Arial") : _ref$font,
          _ref$color = _ref.color,
          color = _ref$color === void 0 ? 'white' : _ref$color,
          _ref$textSpace = _ref.textSpace,
          textSpace = _ref$textSpace === void 0 ? textSize : _ref$textSpace,
          _ref$size = _ref.size,
          size = _ref$size === void 0 ? 100 : _ref$size,
          formatValue = _ref.formatValue,
          minSize = _ref.minSize,
          _ref$ticks = _ref.ticks,
          ticks = _ref$ticks === void 0 ? {} : _ref$ticks,
          _ref$top = _ref.top,
          top = _ref$top === void 0 ? 0 : _ref$top,
          _ref$left = _ref.left,
          left = _ref$left === void 0 ? 0 : _ref$left,
          _ref$right = _ref.right,
          right = _ref$right === void 0 ? 0 : _ref$right,
          _ref$bottom = _ref.bottom,
          bottom = _ref$bottom === void 0 ? 0 : _ref$bottom;

      _classCallCheck(this, Axis);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(Axis).call(this));
      Object.assign(_assertThisInitialized(_this), {
        from: from,
        to: to,
        ticks: ticks,
        textSize: textSize,
        textSpace: textSpace,
        font: font,
        color: color,
        formatValue: formatValue,
        size: size,
        minSize: minSize,
        top: top,
        left: left,
        right: right,
        bottom: bottom
      });
      _this.step = _this.textPos = _this.fromI = _this.toI = _this.path = _this.pathDeps = null;
      _this.isTop = side === 'top';
      _this.isLeft = side === 'left';
      _this.isBottom = side === 'bottom';
      _this.horizontal = _this.isTop || _this.isBottom;
      _this.isTopOrLeft = _this.isTop || _this.isLeft;
      return _this;
    }

    _createClass(Axis, [{
      key: "draw",
      value: function draw() {
        var chart = this.chart,
            top = this.top,
            left = this.left,
            right = this.right,
            bottom = this.bottom,
            ticks = this.ticks;
        var scaleX = chart.scaleX,
            offsetX = chart.offsetX;
        var width = chart.width - left - right;
        var height = chart.height - top - bottom;
        this.setSize(width, height);
        this.setStep(scaleX, width, height);
        this.setTextPos(width, height);
        this.setFromI(offsetX);
        this.setToI(offsetX, width, height);
        this.drawValues(this);
        if (!ticks) return;
        this.checkPath({
          offsetX: offsetX,
          width: width,
          height: height
        });
        this.drawTicks(this);
      }
    }, {
      key: "setSize",
      value: function setSize(width, height) {
        if (!this.minSize) return this.size;
        var dimension = this.horizontal ? width : height;
        var size = this.minSize;

        while (dimension % size) {
          size++;
        }

        return this.size = size;
      }
    }, {
      key: "setStep",
      value: function setStep(scaleX, width, height) {
        return this.step = this.size / (this.horizontal ? scaleX * width : height) * (this.to - this.from);
      }
    }, {
      key: "setTextPos",
      value: function setTextPos(width, height) {
        return this.textPos = this.isTopOrLeft ? this.textSpace : (this.isBottom ? height : width) - this.textSpace;
      }
    }, {
      key: "setFromI",
      value: function setFromI(offsetX) {
        return this.fromI = this.horizontal ? ~~(offsetX / this.size) : 0;
      }
    }, {
      key: "setToI",
      value: function setToI(offsetX, width, height) {
        return this.toI = this.horizontal ? (offsetX + width) / this.size : height / this.size;
      }
    }, {
      key: "getX",
      value: function getX(i) {
        return i * this.size - this.chart.offsetX;
      }
    }, {
      key: "getY",
      value: function getY(i) {
        return i * this.size + this.top;
      }
    }, {
      key: "getValue",
      value: function getValue(i) {
        return this.from + this.step * i;
      }
    }, {
      key: "checkPath",
      value: function checkPath(deps) {
        if (shallowEqual(this.pathDeps, deps)) return;
        this.path = this.createPath();
        this.pathDeps = deps;
      }
    }, {
      key: "createPath",
      value: function createPath() {
        var _this$ticks = this.ticks,
            _this$ticks$offset = _this$ticks.offset,
            offset = _this$ticks$offset === void 0 ? 3 : _this$ticks$offset,
            _this$ticks$size = _this$ticks.size,
            size = _this$ticks$size === void 0 ? 5 : _this$ticks$size,
            fromI = this.fromI,
            toI = this.toI,
            textPos = this.textPos;
        var path = new Path2D();
        var tick1 = textPos + (this.isTopOrLeft ? offset : -offset);
        var tick2 = tick1 + (this.isTopOrLeft ? size : -size);

        if (this.horizontal) {
          for (var i = fromI; i <= toI; i++) {
            var x = this.getX(i);
            path.moveTo(x, tick1);
            path.lineTo(x, tick2);
          }
        } else {
          for (var _i = fromI; _i <= toI; _i++) {
            var y = this.getY(_i);
            path.moveTo(tick1, y);
            path.lineTo(tick2, y);
          }
        }

        return path;
      }
    }, {
      key: "drawValues",
      value: function drawValues() {
        var context = this.chart.context,
            formatValue = this.formatValue,
            fromI = this.fromI,
            toI = this.toI,
            textPos = this.textPos,
            isLeft = this.isLeft;
        context.font = this.font;
        context.fillStyle = this.color;
        context.textBaseline = this.isBottom ? 'top' : this.isTop ? 'bottom' : 'middle';

        if (this.horizontal) {
          for (var i = fromI; i <= toI; i++) {
            var x = this.getX(i);
            var value = this.getValue(i);
            var text = formatValue ? formatValue(value) : value;
            var halfWidth = context.measureText(text).width / 2;
            context.fillText(text, x - halfWidth, textPos);
          }
        } else {
          for (var _i2 = fromI; _i2 <= toI; _i2++) {
            var y = this.getY(_i2);

            var _value = this.getValue(_i2);

            var _text = formatValue ? formatValue(_value) : _value;

            var _x = textPos - (isLeft ? context.measureText(_text).width : 0);

            context.fillText(_text, _x, y);
          }
        }
      }
    }, {
      key: "drawTicks",
      value: function drawTicks() {
        var context = this.chart.context;
        context.strokeStyle = this.ticks.color || this.color;
        context.stroke(this.path);
      }
    }]);

    return Axis;
  }(Component);

  var Component$1 = Component;
  var Events$1 = Events;
  var utils = Utils;
  var Chart =
  /*#__PURE__*/
  function (_Component) {
    _inherits(Chart, _Component);

    function Chart() {
      var _this;

      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          wrapper = _ref.wrapper,
          _ref$height = _ref.height,
          height = _ref$height === void 0 ? 300 : _ref$height,
          _ref$scaleX = _ref.scaleX,
          scaleX = _ref$scaleX === void 0 ? 1 : _ref$scaleX,
          _ref$offsetX = _ref.offsetX,
          offsetX = _ref$offsetX === void 0 ? 0 : _ref$offsetX,
          _ref$items = _ref.items,
          items = _ref$items === void 0 ? [] : _ref$items;

      _classCallCheck(this, Chart);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(Chart).call(this, {}));
      _this.wrapper = wrapper;
      _this.height = height;
      _this.canvas = document.createElement('canvas');
      _this.canvas.height = _this.height;
      _this.width = parseInt(window.getComputedStyle(_this.wrapper).width);
      _this.canvas.width = _this.width;
      _this.events = new Events$1(_this.canvas);
      _this.context = _this.canvas.getContext('2d');
      _this.scaleX = scaleX;
      _this.offsetX = offsetX;
      _this.items = items;
      _this.started = false;

      _this.wrapper.appendChild(_this.canvas);

      return _this;
    }

    _createClass(Chart, [{
      key: "add",
      value: function add(item) {
        this.items.push(item);
        if (this.started) item.start && item.start(this);
      }
    }, {
      key: "remove",
      value: function remove(item) {
        _get(_getPrototypeOf(Chart.prototype), "remove", this).call(this, item);
      }
    }, {
      key: "start",
      value: function start() {
        _get(_getPrototypeOf(Chart.prototype), "start", this).call(this, this);

        this.draw();
      }
    }, {
      key: "stop",
      value: function stop() {
        if (this.started) _get(_getPrototypeOf(Chart.prototype), "stop", this).call(this);
      }
    }, {
      key: "draw",
      value: function draw() {
        if (!this.started) return;
        this.context.clearRect(0, 0, this.width, this.height);

        _get(_getPrototypeOf(Chart.prototype), "draw", this).call(this);
      }
    }]);

    return Chart;
  }(Component$1);

  exports.Axis = Axis;
  exports.Chart = Chart;
  exports.Component = Component$1;
  exports.Events = Events$1;
  exports.RangeSelector = RangeSelector;
  exports.Scroll = Scroll;
  exports.Selection = Selection;
  exports.Wave = Wave;
  exports.Zoom = Zoom;
  exports.utils = utils;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
